#include<bits/stdc++.h>
#pragma GCC optimize ("O3")
#define endl '\n'
using namespace std;
long long a[2000003], t[2000003], last[2000003], m[2000003];
int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    long long n,i,j, sum=0;

    cin>>n;

    for(i=1;i<=n;i++)
    {
        cin>>a[i]>>m[i];

        if(m[i]>0)
        {
            t[i]=t[a[i]]+m[i];
            last[i]=i;
        }
        else
        {
            t[i]=t[a[i]]-m[last[a[i]]];
            last[i]=last[a[last[a[i]]]];
        }
        //cout<<t[i]<<" "<<last[i]<<endl;

        sum+=t[i];
    }
    cout<<sum<<endl;


}

